<template>
  <AppAbstractSearch
    :results-loader="resultsLoader"
    :value="value"
    @input="select"
    @search="search">
    <template
      v-if="$slots['additional-slot']"
      #additional-slot>
      <slot name="additional-slot"/>
    </template>
    <template #suggestion-item="{ suggestion }">
      <div
        @click="select(suggestion)"
        class="suggestion">
        <div class="suggestion-wrapper">
          <div class="suggestion-unit">
            {{ suggestion }}
          </div>
        </div>
      </div>
    </template>
  </AppAbstractSearch>
</template>

<script>
import mapFilters from '~/assets/js/helpers/map-filters';

import AppAbstractSearch from '~/components/redesign/app-search/app-abstract-search';

export default {
  name: 'AppSearchDo',
  components: {
    AppAbstractSearch,
  },
  props: {
    value: {
      type: String,
      default: null,
    },
  },
  methods: {
    ...mapFilters(['brandSlug', 'vendorCodeSlug']),
    resultsLoader(query) {
      return new Promise((resolve) => {
        this.$axios.$get('/_main/contractParts/getPartNameSuggestions', { params: { text: query } })
          .then(({ data }) => {
            if (data) {
              resolve(data);
            }
            resolve([]);
          });
      });
    },
    select(value) {
      this.$emit('input', value);
    },
    search() {
      this.$emit('search');
    },
  },
};
</script>

<style lang="postcss">
</style>
